<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/set_lock_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>10/04/85  set_lock_
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>The set_lock_ subroutine enables cooperating processes to coordinate
<span id="L4" class="LineNr"> 4 </span>their use of shared resources.
<span id="L5" class="LineNr"> 5 </span>
<span id="L6" class="LineNr"> 6 </span>
<span id="L7" class="LineNr"> 7 </span>Entry points in set_lock_:
<span id="L8" class="LineNr"> 8 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L9" class="LineNr"> 9 </span>
<span id="L10" class="LineNr">10 </span>
<span id="L11" class="LineNr">11 </span>:Entry: lock:  10/04/85  set_lock_$lock
<span id="L12" class="LineNr">12 </span>
<span id="L13" class="LineNr">13 </span>
<span id="L14" class="LineNr">14 </span>Function:  This entry point attempts to place the lock identifier of
<span id="L15" class="LineNr">15 </span>the calling process in the given lock word.
<span id="L16" class="LineNr">16 </span>
<span id="L17" class="LineNr">17 </span>
<span id="L18" class="LineNr">18 </span>Usage:
<span id="L19" class="LineNr">19 </span>declare set_lock_$lock entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L20" class="LineNr">20 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L21" class="LineNr">21 </span>call set_lock_$lock <span class="textRainbow_lv0_p0">(</span>lock_word<span class="textRainbow_lv0_o0">,</span> wait_time<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L22" class="LineNr">22 </span>
<span id="L23" class="LineNr">23 </span>
<span id="L24" class="LineNr">24 </span>Arguments:
<span id="L25" class="LineNr">25 </span>lock_word
<span id="L26" class="LineNr">26 </span>   is the word to be locked.  <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span>
<span id="L27" class="LineNr">27 </span>wait_time
<span id="L28" class="LineNr">28 </span>   indicates the length of real time, in seconds, that the
<span id="L29" class="LineNr">29 </span>   set_lock_$lock entry point should wait for a validly locked lock
<span id="L30" class="LineNr">30 </span>   word to be unlocked before returning unsuccessfully.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> A
<span id="L31" class="LineNr">31 </span>   value of -1 indicates no time limit.
<span id="L32" class="LineNr">32 </span>
<span id="L33" class="LineNr">33 </span>
<span id="L34" class="LineNr">34 </span>code
<span id="L35" class="LineNr">35 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It can be one of the following:
<span id="L36" class="LineNr">36 </span>   error_table_$invalid_lock_reset
<span id="L37" class="LineNr">37 </span>        indicates that the lock word was successfully locked, but the
<span id="L38" class="LineNr">38 </span>        lock word previously contained an invalid lock identifier that
<span id="L39" class="LineNr">39 </span>        was overwritten
<span id="L40" class="LineNr">40 </span>   error_table_$locked_by_this_process
<span id="L41" class="LineNr">41 </span>        indicates that the lock word already contained the lock
<span id="L42" class="LineNr">42 </span>        identifier of the calling process and was not modified
<span id="L43" class="LineNr">43 </span>   error_table_$lock_wait_time_exceeded
<span id="L44" class="LineNr">44 </span>        indicates that the lock word contained a valid lock identifier
<span id="L45" class="LineNr">45 </span>        of another process and could not be locked in the given time
<span id="L46" class="LineNr">46 </span>        limit
<span id="L47" class="LineNr">47 </span>
<span id="L48" class="LineNr">48 </span>
<span id="L49" class="LineNr">49 </span>   error_table_$no_w_permission
<span id="L50" class="LineNr">50 </span>        indicates that calling process does not have proper write
<span id="L51" class="LineNr">51 </span>        permission to lock_word
<span id="L52" class="LineNr">52 </span>
<span id="L53" class="LineNr">53 </span>
<span id="L54" class="LineNr">54 </span>Notes:
<span id="L55" class="LineNr">55 </span>It is suggested that set_lock_$lock be called as follows for
<span id="L56" class="LineNr">56 </span>applications where efficiency is important:
<span id="L57" class="LineNr">57 </span>
<span id="L58" class="LineNr">58 </span>   if ^stacq <span class="textRainbow_lv0_p0">(</span>lock_word<span class="textRainbow_lv0_o0">,</span> static_var_initialized_to_lock_id<span class="textRainbow_lv0_o0">,</span> &quot;&quot;b<span class="textRainbow_lv0_p0">)</span>
<span id="L59" class="LineNr">59 </span>      then call set_lock_$lock <span class="textRainbow_lv0_p0">(</span>lock_word<span class="textRainbow_lv0_o0">,</span> wait_time<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L60" class="LineNr">60 </span>      else code = 0;
<span id="L61" class="LineNr">61 </span>
<span id="L62" class="LineNr">62 </span>
<span id="L63" class="LineNr">63 </span>:Entry: unlock:  10/04/85  set_lock_$unlock
<span id="L64" class="LineNr">64 </span>
<span id="L65" class="LineNr">65 </span>
<span id="L66" class="LineNr">66 </span>Function:  This entry point attempts to reset a given lock word to &quot;0&quot;b
<span id="L67" class="LineNr">67 </span>and is successful if the lock word contained the lock identifier of the
<span id="L68" class="LineNr">68 </span>calling process.
<span id="L69" class="LineNr">69 </span>
<span id="L70" class="LineNr">70 </span>
<span id="L71" class="LineNr">71 </span>Usage:
<span id="L72" class="LineNr">72 </span>declare set_lock_$unlock entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L73" class="LineNr">73 </span>call set_lock_$unlock <span class="textRainbow_lv0_p0">(</span>lock_word<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L74" class="LineNr">74 </span>
<span id="L75" class="LineNr">75 </span>
<span id="L76" class="LineNr">76 </span>Arguments:
<span id="L77" class="LineNr">77 </span>lock_word
<span id="L78" class="LineNr">78 </span>   is the lock word to be reset.  <span class="textRainbow_lv0_p0">(</span>Input/Output<span class="textRainbow_lv0_p0">)</span>
<span id="L79" class="LineNr">79 </span>code
<span id="L80" class="LineNr">80 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L81" class="LineNr">81 </span>   error_table_$lock_not_locked
<span id="L82" class="LineNr">82 </span>        indicates that the lock was not locked
<span id="L83" class="LineNr">83 </span>   error_table_$locked_by_other_process
<span id="L84" class="LineNr">84 </span>        indicates that the lock was not locked by this process and
<span id="L85" class="LineNr">85 </span>        therefore was not unlocked
<span id="L86" class="LineNr">86 </span>   error_table_$no_w_permission
<span id="L87" class="LineNr">87 </span>        indicates that calling process does not have proper write
<span id="L88" class="LineNr">88 </span>        permission to lock_word
<span id="L89" class="LineNr">89 </span>
<span id="L90" class="LineNr">90 </span>
<span id="L91" class="LineNr">91 </span>Notes:
<span id="L92" class="LineNr">92 </span>It is suggested that set_lock_$unlock be called as follows for
<span id="L93" class="LineNr">93 </span>applications where efficiency is important:
<span id="L94" class="LineNr">94 </span>
<span id="L95" class="LineNr">95 </span>   if ^stacq <span class="textRainbow_lv0_p0">(</span>lock_word<span class="textRainbow_lv0_o0">,</span> &quot;&quot;b<span class="textRainbow_lv0_o0">,</span> static_var_initialized_to_lock_id<span class="textRainbow_lv0_p0">)</span>
<span id="L96" class="LineNr">96 </span>      then call set_lock_$unlock <span class="textRainbow_lv0_p0">(</span>lock_word<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L97" class="LineNr">97 </span>      else code = 0;
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
